## TensorTrade

[TensorTrade](https://github.com/notadamking/tensortrade) is an open source Python framework for building, training, evaluating, and deploying robust trading algorithms using reinforcement learning. This framework aims to extend the existing ML pipelines created by pandas, gym, sklearn, keras, and tensorflow in a simple, intuitive way.

Allow state-of-the-art learning agents to improve your trading strategies and take you from idea to production, in a repeatable, maintable way.

TensorTrade enable fast experimentation, while maintaining production-quality data pipelines.

## Guiding principles

User friendliness. TensorTrade is an API designed for human beings, not machines. It puts user experience front and center. TensorTrade follows best practices for reducing cognitive load: it offers consistent & simple APIs, it minimizes the number of user actions required for common use cases, and it provides clear and actionable feedback upon user error.

Modularity. A trading environment is a conglomeration of fully configurable modules that can be plugged together with as few restrictions as possible. In particular, asset exchanges, feature pipelines, action strategies, reward strategies, trading agents, and performance reports are all standalone modules that you can combine to create new trading pipelines.

Easy extensibility. New modules are simple to add (as new classes and functions), and existing modules provide ample examples. To be able to easily create new modules allows for total expressiveness, making TensorTrade suitable for advanced research and production use.
